unit ucontrolepedido;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, DB, DBTables, StdCtrls, Buttons, DBCtrls, ExtCtrls,
  Grids, DBGrids, ComCtrls;

type
  Tfcontrolepedido = class(TForm)
    StatusBar1: TStatusBar;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    DBText1: TDBText;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Label2: TLabel;
    DBText2: TDBText;
    SpeedButton3: TSpeedButton;
    DataSource1: TDataSource;
    ActionList1: TActionList;
    foco: TAction;
    imprimirA: TAction;
    imprimirT: TAction;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    DBGrid2: TDBGrid;
    Panel5: TPanel;
    DBText3: TDBText;
    DBText4: TDBText;
    ajuda: TAction;
    procedure focoExecute(Sender: TObject);
    procedure imprimirAExecute(Sender: TObject);
    procedure imprimirTExecute(Sender: TObject);
    procedure DBText1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure DBGrid2ColExit(Sender: TObject);
    procedure DBGrid2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure DBText4Click(Sender: TObject);
    procedure ajudaExecute(Sender: TObject);
  private

  procedure AppHint(Sender : TObject);

    { Private declarations }
  public
    { Public declarations }
  end;

var
  fcontrolepedido: Tfcontrolepedido;

implementation

uses upedido, UnitRelatorio, UnitMenu, udm, clipbrd;

{$R *.dfm}


procedure Tfcontrolepedido.AppHint(Sender: TObject);
begin
  StatusBar1.Panels[0].Text := Application.Hint;
end;


procedure Tfcontrolepedido.focoExecute(Sender: TObject);
begin
        if dbgrid1.Focused = true then
         dbgrid2.SetFocus
        else
         dbgrid1.SetFocus;

end;

procedure Tfcontrolepedido.imprimirAExecute(Sender: TObject);
var
pd:string;
bookmark : tbookmarkstr;
begin


       bookmark := fdm.tbpedido.bookmark;

       if  application.MessageBox('Imprimir somente este pedido?','Imprimir pedido (s)',4 + MB_ICONWARNING ) = mryes then begin

         pd := (fdm.tbpedido['pedido']);

        fdm.tbpedido.Filter := 'pedido='''+ pd +'''';
         fdm.tbpedido.filtered := true;
          end;


        Application.CreateForm(tFrPedido, FrPedido);

       fmenu.logotipoExecute(self);
        if fileexists (extractfilepath(paramstr(0)) + '\imagem\logo.bmp') then begin
         FrPedido.imagem5.Picture.assign(clipboard);
          clipboard.clear;
  end;

    if fileexists (extractfilepath(paramstr(0)) + '\imagem\dado.txt') then
     FrPedido.memo5.lines.loadfromfile(extractfilepath(paramstr(0)) + '\imagem\dado.txt');

      FrPedido.quickpedidosaldo.previewmodal;
       FrPedido.Release;
        fdm.tbpedido.Filtered := false;

          fdm.tbpedido.Bookmark := bookmark;


end;

procedure Tfcontrolepedido.imprimirTExecute(Sender: TObject);
begin
       with fdm.query1 do begin
        close;
         sql.clear;
          sql.add('select * from tbpedidoitem where saldo > "0" order by pedido');
           open;
            end;

            if fdm.query1['codigo']<> null then begin

        Application.CreateForm(tFrPedido, FrPedido);

       fmenu.logotipoExecute(self);
        if fileexists (extractfilepath(paramstr(0)) + '\imagem\logo.bmp') then begin
         FrPedido.image6.Picture.assign(clipboard);
          clipboard.clear;
  end;

    if fileexists (extractfilepath(paramstr(0)) + '\imagem\dado.txt') then
     FrPedido.memo6.lines.loadfromfile(extractfilepath(paramstr(0)) + '\imagem\dado.txt');

      FrPedido.quickpedidosaldotudo.previewmodal;
       FrPedido.Release;


    end else showmessage('Não há saldo em nenhum pedido');

        fdm.query1.close;

end;

procedure Tfcontrolepedido.DBText1Click(Sender: TObject);
var
st:string;
bok:boolean;
begin
        BOK := inputquery('Localizar Pedido','Entre com o número:',ST);
         if BOK then
          if not fdm.tbpedido.Locate ('pedido',ST,[]) then
           ShowMessage ('Pedido não encontrado!!!');
            ST := '';


end;

procedure Tfcontrolepedido.SpeedButton2Click(Sender: TObject);
begin
        fdm.tbpedido.Prior;
end;

procedure Tfcontrolepedido.SpeedButton1Click(Sender: TObject);
begin
        fdm.tbpedido.Next;
end;

procedure Tfcontrolepedido.SpeedButton3Click(Sender: TObject);
var
st:string;
begin
          st:='A';

        if inputquery ('Opções de impressão','Digite "A" para imprimir todos os ítens' + #13 + 'Digite "T" para imprimir somente saldo:', st) then

          if uppercase(st) ='A' then
           imprimirAexecute(self)
          else  if uppercase(st) ='T' then
           imprimirTexecute(self)
          else
           ShowMessage('Esta opção não é válida');


end;

procedure Tfcontrolepedido.DBGrid2ColExit(Sender: TObject);
var
tot: real;
bookmark : tbookmarkstr;
begin

     bookmark := fdm.tbpedidobaixa.Bookmark;

     try
      fdm.tbpedidobaixa.DisableControls;
      tot := 0;

    try
    fdm.tbpedidobaixa.First;

    while not fdm.tbpedidobaixa.Eof do begin

    tot := tot + (fdm.tbpedidobaixa.fieldbyname ('qtd') as tfloatfield).Value;
    fdm.tbpedidobaixa.next;
    end;
    finally

    fdm.tbpedidobaixa.EnableControls;
    end;
    finally
    fdm.tbpedidobaixa.Bookmark := bookmark;
    end;


    if tot <= fdm.tbpedidoitem['qtd'] then begin
     fdm.tbpedidoitem.Edit;
      fdm.tbpedidoitem['qtdentrada'] := tot;
       fdm.tbpedidoitem['saldo'] := (fdm.tbpedidoitem.fieldbyname ('qtd') as tfloatfield).Value -
        (fdm.tbpedidoitem.fieldbyname ('qtdentrada') as tfloatfield).Value;
         fdm.tbpedidoitem.post;

    end else begin

     Showmessage ('A entrada é maoir que o pedido!!!    Verificar!!!');
      fdm.tbpedidobaixa.Edit;
       fdm.tbpedidobaixa['qtd'] := null;
        abort;
         end;


end;

procedure Tfcontrolepedido.DBGrid2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
        if key = 13 then
         if dbgrid2.SelectedIndex = 0 then
           dbgrid2.SelectedIndex := 1
         else
           dbgrid2.SelectedIndex := 0;


        if key = 27 then
         if dbgrid2.SelectedIndex = 0 then
           dbgrid2.SelectedIndex := 1
         else
           dbgrid2.SelectedIndex := 0;

end;

procedure Tfcontrolepedido.FormActivate(Sender: TObject);
begin
  fdm.tbpedidobaixa.Open;
 (fdm.tbpedidobaixa.fieldbyname ('dataentrada') as tdatetimefield).editmask:= '99/99/9999';
 (fdm.tbpedidobaixa.fieldbyname ('qtd') as tfloatfield).displayformat := '00';
 dbgrid2.SetFocus;
 dbgrid2.SelectedIndex := 0;

end;

procedure Tfcontrolepedido.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
        Application.OnHint := nil; 
        fdm.tbpedidobaixa.Close;
end;

procedure Tfcontrolepedido.FormCreate(Sender: TObject);
begin
  Application.OnHint := AppHint;
end;

procedure Tfcontrolepedido.DBText4Click(Sender: TObject);
var
st:string;
bok:boolean;
begin
        BOK := inputquery('Localizar Pedido','Entre com o nome do cliente:',ST);
         if BOK then
          if not fdm.tbpedido.Locate ('fantasia',uppercase(ST),[]) then
           ShowMessage ('Cliente não encontrado!!!');
            ST := '';


end;

procedure Tfcontrolepedido.ajudaExecute(Sender: TObject);
var
  Comp: Trichedit; // * variável Comp da classe TMemo
  texto : string;
begin
  Comp := Trichedit.Create (Self);  // * cria o componente Memo
  Comp.Parent := Self;    // * exibe o componente criado

  if fileexists (extractfilepath(paramstr(0)) + '\ajuda\ajudapedidobaixa.txt') then
   comp.lines.loadfromfile (extractfilepath(paramstr(0)) + '\ajuda\ajudapedidobaixa.txt');

  texto := comp.Text;
  comp.Destroy;

  Showmessage (texto);


end;

end.
